using System;
using System.Collections.Generic;
using System.Text;

using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;
using DBTransMan = Autodesk.AutoCAD.DatabaseServices.TransactionManager;



[assembly: CommandClass(typeof(Lib.Start))]


namespace Lib
{
    public class Start
    {
        [CommandMethod("dragTest")]
        static public void DoIt()
        {
            draggen dg = new draggen();

            dg.dragEntity();
        }

    }

    public class draggen
    {

        
       
        public bool dragEntity()
        {

            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            PromptEntityResult res = ed.GetEntity("\nObjekt whlen: ");


            if (res.Status != PromptStatus.OK)
                return false;

            ObjectId id = res.ObjectId;
           
            PromptPointOptions opts = new PromptPointOptions("\nStartpunkt:");
            PromptPointResult resP = ed.GetPoint(opts);

            Point3d po = resP.Value;

            
            Database db = Application.DocumentManager.MdiActiveDocument.Database;
            Autodesk.AutoCAD.DatabaseServices.TransactionManager tm = db.TransactionManager;

            //Append entity.
            using (Transaction myT = tm.StartTransaction())
            {

                Entity ent = (Entity)tm.GetObject(id, OpenMode.ForWrite, false);
 
                //Create Ellipsejig
                MyEntityJig jig = new MyEntityJig(ref ent, po);
                
                Application.DocumentManager.MdiActiveDocument.Editor.Drag(jig);
           
                myT.Commit();
            }

            return true;
        }
    }
}
